From f22460f095739b9f3b6ded6f550ecb4398b9c07c Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 13 2017 12:55:18 +0000
Subject: [PATCH 38/51] add @prerequisite_for decorator


This reverse of the @prerequisite decorator accepts globs and allows to
apply a prerequisite to many linter methods at once. This is useful e.g.
for linter methods which are only to be run if an optional block exists,
if the method names somehow map to the hierarchical level of what they
check. It also allows checking that a modulemd YAML file is processed to
begin with (or skip all other tests if not).

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 9d9555a..6a06243 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -74,6 +74,8 @@ class LintLevel(object):
         fn.lint_level = self.level
         fn.lint_level_name = self.level_name
         fn.lint_order = LintLevel.lint_order
+        if not hasattr(fn, 'lint_prerequisites'):
+            fn.lint_prerequisites = set()
         LintLevel.lint_order += 1
         return fn
 
@@ -95,26 +97,39 @@ class detail(object):
         return fn
 
 
-class prerequisite(object):
-    """Decorate a linter method with what checks are a prerequisite so as to
-    not overwhelm a user with subsequent errors."""
+class prerequisite_base(object):
+    """Base class for the @prerequisite, @prerequisite_for decorators."""
 
-    def __init__(self, *prerequisites):
-        assert len(prerequisites)
+    attr_name = None
 
-        # Allow specification with and without "lint_" prefix
-        prerequisites = set(x if x.startswith("lint_") else "lint_" + x
-                            for x in prerequisites)
+    def __init__(self, *names):
+        assert len(names)
 
-        self.prerequisites = prerequisites
+        # Allow specification with and without "lint_" prefix
+        self.names = set(x if x.startswith("lint_") else "lint_" + x
+                         for x in names)
 
     def __call__(self, fn):
         try:
-            fn.lint_prerequisites.update(self.prerequisites)
+            getattr(fn, self.attr_name).update(self.names)
         except AttributeError:
-            fn.lint_prerequisites = self.prerequisites
+            setattr(fn, self.attr_name, self.names)
         return fn
 
+class prerequisite(prerequisite_base):
+    """Decorate a linter method with what checks are a prerequisite so as to
+    not overwhelm a user with subsequent errors."""
+
+    attr_name = 'lint_prerequisites'
+
+
+class prerequisite_for(prerequisite_base):
+    """Decorate a linter method with what checks have it as a prerequisite.
+
+    Accepts globs."""
+
+    attr_name = 'lint_prerequisites_for'
+
 
 class LintCheckFailed(Exception):
     pass
@@ -189,6 +204,20 @@ class ModuleMDLinter(object):
                                  or y.lint_level >= min_level)),
             key=lambda x: x.lint_order)
 
+        names_to_methods = {m.__name__: m for m in lint_methods}
+
+        # add names of methods decorated with @prerequisite_for to the list of
+        # prerequisites of matching methods
+        for method in lint_methods:
+            name = method.__name__
+            for glob in getattr(method, 'lint_prerequisites_for', ()):
+                matching_names = fnmatch.filter(names_to_methods, glob)
+                for n in matching_names:
+                    # don't apply to decorated method
+                    if n == name:
+                        continue
+                    names_to_methods[n].lint_prerequisites.add(name)
+
         # ensure all lint methods have a docstring
         assert all(
             getattr(x, '__doc__', None)

